//
//	MiscAppKit.h -- Header for the MiscKit AppKit extension.
//		Written by Don Yacktman Copyright 1997 by Don Yacktman.
//				Version 0.4.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>
#import <Foundation/Foundation.h>
#import <MiscFoundation/MiscFoundation.h>

// NeXT Kit additions (top level)

#import <MiscAppKit/NSUserDefaults+MiscColorExtensions.h>
#import <MiscAppKit/NSImage+MiscComparing.h>
#import <MiscAppKit/NSTableView+MiscColumnHandling.h>
#import <MiscAppKit/NSColor+MiscExtensions.h>
#import <MiscAppKit/NSImage+MiscExtensions.h>

// From the top level

#import <MiscAppKit/MiscAppIconAnimator.h>
#import <MiscAppKit/MiscRubberband.h>
#import <MiscAppKit/MiscZooming.h>
#import <MiscAppKit/MiscZoomScrollView.h>
#import <MiscAppKit/MiscControlPoints.h>
#import <MiscAppKit/MiscCoordAdditions.h>

// From MiscArrowButton

#import <MiscAppKit/MiscArrowButtonCell.h>
#import <MiscAppKit/MiscArrowButton.h>

// From MiscGauge

#import <MiscAppKit/MiscGaugeCell.h>
#import <MiscAppKit/MiscGaugeView.h>

// From MiscUserPath

#import <MiscAppKit/MiscUserPath.h>
#import <MiscAppKit/MiscHitPath.h>

// From MiscProgressView

#import <MiscAppKit/MiscProgressView.h>
#import <MiscAppKit/MiscProgressPie.h>
#import <MiscAppKit/MiscProgressBar.h>

// From MiscTreeDiagram

#import <MiscAppKit/MiscDiagramShape.h>
#import <MiscAppKit/MiscDiagramTree.h>
#import <MiscAppKit/MiscNodeStyle.h>
#import <MiscAppKit/MiscTreeDiagram.h>
#import <MiscAppKit/MiscTreeDiagramView.h>
#import <MiscAppKit/MiscTreeStyle.h>
#import <MiscAppKit/MiscTDDocAPI.h>

// From MiscImageDecoder

#import <MiscAppKit/MiscImageDecoderController.h>
#import <MiscAppKit/MiscImageDecoder.h>
#import <MiscAppKit/MiscTIFFDecoder.h>
#import <MiscAppKit/MiscJPEGDecoder.h>
#import <MiscAppKit/MiscPNGDecoder.h>
#import <MiscAppKit/MiscGIFData.h>
#import <MiscAppKit/MiscGIFDecoder.h>

// From MiscSwapKit

#import <MiscAppKit/MiscSwapView.h>
#import <MiscAppKit/MiscSwapView_ByObject.h>
#import <MiscAppKit/MiscSwapViewItem.h>
