/*	MiscPNGDecoder.h

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

*/

#import <AppKit/AppKit.h>

#import "MiscImageDecoder.h"

#import <MiscSupport/png.h>

typedef struct _MiscPNGSource {
		NSData *infile;			/* source stream */
		unsigned int bytesRead;		/* bytes already read */
		unsigned int infileLength;	/* length of infile */
} MiscPNGSource;

typedef struct _MiscPNGError {
		jmp_buf setjmp_buffer;
    		id decoder;
} MiscPNGError;

@interface MiscPNGDecoder:MiscImageDecoder
{
	png_structp png_ptr;
    	png_infop info_ptr;
     	png_infop end_info;
	MiscPNGSource source;
        MiscPNGError error;
	char **rows;
}


@end
