#ifndef __MiscBorderCell_h
#define __MiscBorderCell_h
//=============================================================================
//
//	Copyright (C) 1995-1997 by Paul S. McCarthy and Eric Sunshine.
//		Written by Paul S. McCarthy and Eric Sunshine.
//			    All Rights Reserved.
//
//	This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the authors
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//=============================================================================
//-----------------------------------------------------------------------------
// MiscBorderCell.h
//
//	Cell class used by MiscBorderView to manage column headings and row 
//	labels for MiscTableScroll.  
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscBorderCell.h,v 1.4 97/03/23 05:45:42 sunshine Exp $
// $Log:	MiscBorderCell.h,v $
//  Revision 1.4  97/03/23  05:45:42  sunshine
//  v125.4: Worked around OPENSTEP 4.1 bug where -setupFieldEditorAttributes:
//  never gets called, so text was not drawing white.  Worked around problem by
//  subclassing from NSTextFieldCell rather than NSCell.  This way color can
//  be set with -setTextColor:.
//  
//  Revision 1.3  96/12/30  06:27:24  sunshine
//  v105.1: Added the image instance variable.
//  
//  Revision 1.2  96/04/30  05:38:10  sunshine
//  Ported to OpenStep 4.0 for Mach PR2.
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <AppKit/NSTextFieldCell.h>
}
class NSImage;

@interface MiscBorderCell : NSTextFieldCell
    {
    NSImage* image;
    }

- (void)setImage:(NSImage*)image;

@end

#endif // __MiscBorderCell_h
