//************************************************************************
//
//	OICNSTableColumn.h
//
//	by Juergen Moellenhoff <jm@oic.de>		
//
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import <AppKit/NSTableColumn.h>

@interface OICNSTableColumn : NSTableColumn <NSCopying, NSCoding>
{
@protected
	NSComparisonResult	_ordering;
	BOOL				_caseInsensitive;
}

// Class methods
+ (void)initialize;

//
// NSCoding protocol
//
- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

//
// NSCopying protocol
//
- copyWithZone:(NSZone *)z;

//
// Get/Set methods
//
- (void)setOrdering:(NSComparisonResult)newOrdering;
- (NSComparisonResult)ordering;

- (void)setCaseInsensitive:(BOOL)flag;
- (BOOL)isCaseInsensitive;

//
// Catch awakeFromNib
//
- (void)awakeFromNib;

//
// Catch the method from NSTableColumn.
//
- (void)setHeaderCell:(id)aCell;

@end
